rem 
rem $Header: catproc.sql 17-aug-99.17:35:23 rshaikh Exp $ 
rem 
Rem  Copyright (c) 1991, 1995, 1996, 1997, 1998, 1999 by Oracle Corporation 
Rem    NAME
Rem      catproc.sql
Rem    DESCRIPTION
Rem	 Run all sql scripts for the procedural option
Rem    RETURNS
Rem 
Rem    NOTES
Rem      This script must be run while connectd as SYS or INTERNAL.
Rem    MODIFIED   (MM/DD/YY)
Rem     rpang      08/13/99 - Added dbms_psp after dbms_sql and utl_raw
Rem     rpang      08/02/99 - Added utl_raw, utl_tcp, utl_smtp and utl_inaddr
Rem     bnainani   07/30/99 - Bug 915265 - change file names to 8 chars
Rem     jkundu     07/21/99 - Logminer sql filenames changed to 8.3 format
Rem     nshodhan   03/23/99 - add comments
Rem     nshodhan   02/26/99 - bug-789058: Remove obsolete files
Rem     ato        12/12/98 - add prvtzexp.plb
Rem     weiwang    11/16/98 - add system event attribute functions
Rem     slawande   11/04/98 - Load prvtsnap.plb before prvtsum.plb.
Rem     akalra     11/02/98 - get security helper functions for imp-exp
Rem     ato        11/02/98 - add prvtzhelp.plb                               
Rem     lcprice    11/02/98 - add dbms_repair package
Rem     rxgovind   10/14/98 - Remove RowType and RowSet install
Rem     dmwong     09/23/98 - add catactx for application context              
Rem     hasun      08/25/98 - Reorder <>snap and <>sum for dependencies        
Rem     rshaikh    06/22/98 - add catsvrmg after catspace
Rem     akalra     06/09/98 - catsched.sql -> catrm.sql
Rem     hasun      06/04/98 - Reorder prvtsnap and prvtsum to resolve depdencie
Rem     qiwang     05/28/98 - Add prvtsmv.plb
Rem     mcusson    05/11/98 - Name change: LogViewr -> LogMnr.
Rem     nle        05/13/98 - change file name: plspurity to plspur
Rem     rmurthy    05/04/98 - add catodci.sql
Rem     jwlee      05/18/98 - load catplug
Rem     nle        04/27/98 - execute plspurity
Rem     jwlee      04/05/98 - load prvtplts.plb
Rem     clei       03/09/98 - add catalog for row level security
Rem     sichandr   05/06/98 - make UTL_COLL package part of default installatio
Rem     svivian    04/16/98 - add stored outline metadata
Rem     doshaugh   04/13/98 - Add Logviewr packages
Rem     esoyleme   04/15/98 - add rules
Rem     rxgovind   04/12/98 - install SYS.RowType and SYS.RowSet
Rem     sramakri   04/08/98 - Add loading of prvtsma.plb (Summary Advisor packa
Rem     ciyer      03/30/98 - Load PL/SQL tracing packages
Rem     rxgovind   03/10/98 - make UTL_REF package part of default installation
Rem     clei       03/09/98 - add catalog for row level security
Rem     wnorcott   02/05/98 - Add prvtsum.sql
Rem     akalra     01/20/98 - Add catsched.sql
Rem     amozes     01/09/98 - add dbmsstat package
Rem     bhimatsi   02/27/98 - add call to catspace.sql
Rem     gclossma   09/09/97 - add .plb suffix to load of prvtpckl
Rem     gclossma   08/14/97 - add prvtpckl.plb for dbms_pickler
Rem     gdoherty   05/09/97 - add back catsnmp
Rem     gdoherty   04/29/97 - remove catsnmp.sql
Rem     rwessman   04/18/97 - Deleted catoctk.sql - it must be run after catpro
Rem     dalpern    04/16/97 - added on-disk rman packages
Rem     rwessman   04/15/97 - Add cryptographic toolkit interface
Rem     gclossma   04/14/97 - add pkg utlhttp for http callouts
Rem     gviswana   04/01/97 - Move prvtssql.plb down after dbmssql.sql
Rem     nlewis     03/20/97 - add prvttrst.sql - distributed trust admin
Rem     celsbern   01/07/97 - moved catsnap after catdefer and catqueue
Rem     ato        11/08/96 - add catqueue.sql
Rem     mchien     11/07/96 - fix '@' sign
Rem     wuling     11/07/96 - Add PITR Package
Rem     mchien     10/24/96 - add dbmslob to here
Rem     jmallory   10/22/96 - Load Probe packages
Rem     gdoherty   10/15/96 - move prvtssql.plb above other specs
Rem     mluong     10/14/96 - rearrange order for 'packages used for rdbms func
Rem     apareek    10/08/96 - New file for tspitr views (catpitr.sql)
Rem     sjain      09/09/96 - AQ conversion
Rem     nmichael   08/19/96 - New file for dynamic sql (prvtssql.sql)
Rem     asurpur    08/02/96 - Including prvtxpsw.sql to import password stuff
Rem     asurpur    05/06/96 - Dictionary Protection Implementation
Rem     ajasuja    04/25/96 -  merge OBJ to BIG_0423
Rem     wmaimone   01/04/96 -  7.3 merge
Rem     ldoo       12/10/95 -  Add dbmsitrg
Rem     tpystyne   04/09/96 - do not create standard since it is fixed now
Rem     emendez    09/29/95 -
Rem     dsdaniel   06/07/95 -  clean up .plb
Rem     dposner    04/26/95 -  Adding fileio packages
Rem     kmuthukk   03/13/95 -  add plitblm.sql for pl/sql index-table methods
Rem     wmaimone   05/06/94 -  #184921 run as sys/internal
Rem     dsdaniel   04/07/94 -  merge changes from branch 1.5.710.5
Rem     adowning   03/29/94 -  merge changes from branch 1.5.710.[6,7]
Rem     adowning   02/23/94 -  use prvt*.sql for non-replication
Rem     adowning   02/02/94 -  incorporate public/private file splits
Rem     dsdaniel   01/31/94 -  add dbmspexp.sql for export extensions
Rem     rjenkins   01/19/94 -  merge changes from branch 1.5.710.4
Rem     dsdaniel   01/18/94 -  merge changes from branch 1.5.710.2
Rem     rjenkins   12/08/93 -  un-merging dbmssyer
Rem     rjenkins   11/17/93 -  merge changes from branch 1.5.710.3
Rem     rjenkins   12/20/93 -  creating job queue
Rem     rjenkins   11/03/93 -  do dbmssnap after dbmssql
Rem     dsdaniel   10/30/93 -  add dbmssyer.sql
Rem     dsdaniel   10/29/93 -  run catdefr instead of dbmsdfrd
Rem     rjenkins   10/20/93 -  merge changes from branch 1.5.710.1
Rem     rjenkins   10/14/93 -  calling dbmsdfrd.sql
Rem     rjenkins   10/07/93 -  run dbmsdfrd.sql
Rem     hjakobss   07/09/93 -  add dbmssql
Rem     mmoore     11/03/92 -  add dbmsdesc 
Rem     glumpkin   10/26/92 -  Change catremot catrpc 
Rem     glumpkin   10/25/92 -  Change catstdx.sql to dbmsstdx.sql 
Rem     glumpkin   10/25/92 -  Creation 

Rem basic procedural views
@@catprc
@@catjobq

Rem Remote views
@@catrpc

Rem Setup for pl/sql
@@dbmsstdx
@@plitblm
@@plspur
@@pipidl
rem granting execute on the package created in pipidl.sql 
rem to execute_catalog_role...
grant execute on pidl to execute_catalog_role
/
@@pidian
rem granting execute on the package created in pidian.sql 
rem to execute_catalog_role...
grant execute on diana to execute_catalog_role
/
@@diutil
@@pistub
@@utlhttp
@@prvtpckl.plb
Rem packages implementing PL/SQL file data type
@@utlfile
@@prvtfile.plb
Rem more PL/SQL I/O packages
@@utlraw
@@prvtrawb.plb
@@utltcp
@@prvttcp.plb
@@utlinad
@@prvtinad.plb
@@utlsmtp
@@prvtsmtp.plb

Rem include catspace.sql as it has space mgmt view and packages. we do it
Rem first as one of the following may have a reference to it
@@catspace

Rem Views for Application context ( dbmsutil and prvtutil depends on it )
@@catactx.sql

Rem Server Manager views -- depends on views created in catspace
@@catsvrmg

Rem pl/sql packages used for rdbms functionality
@@dbmsutil
@@dbmsapin
@@dbmssyer
@@dbmslock
@@dbmspipe
@@dbmsalrt
@@dbmsotpt
@@dbmsdesc
@@dbmssql
@@dbmspexp
@@dbmsjob
@@dbmsstat
@@prvtutil.plb
@@prvtapin.plb
@@prvtsyer.plb
@@prvtlock.plb
@@prvtpipe.plb
@@prvtalrt.plb
@@prvtotpt.plb
@@prvtdesc.plb
@@prvtssql.plb
@@prvtsql.plb
@@prvtpexp.plb
@@prvtzhlp.plb
@@prvtzexp.plb
@@prvtjob.plb
@@prvtstat.plb
Rem PL/SQL Server Pages package
@@dbmspsp
@@prvtpsp.plb

Rem Rules engine
@@catrule.sql
@@dbmsread.sql
@@prvtread.plb

Rem Tables, Views and Packages for AQ
@@catqueue

Rem Packages for DB Resource Manager
@@catrm

Rem Views and tables for deferred RPC and Materialized Views
@@catdefer
@@catsnap

Rem dbmsdfrd is replaced by dbmsdefr for the replication option
@@prvtdfrd.plb
@@prvtitrg.plb
@@prvtxpsw.plb

Rem Probe packages
@@dbmspb.sql
@@prvtpb.plb

REM packages for Summary Management and Materialized Views
@@dbmssum
@@dbmssnap
@@prvtsnap.plb
@@prvtsum.plb
@@prvtsmv.plb
@@prvtsma.plb
  
Rem PL/SQL trace packages
@@dbmspbt.sql
@@prvtpbt.plb

Rem Views for tablespace point in time recovery
@@catpitr
Rem dbms_pitr package spec and body
@@dbmspitr
@@prvtpitr.plb

Rem Views for transportable tablespace
@@catplug
@@dbmsplts
@@prvtplts.plb

Rem pl/sql packages for LOB
@@dbmslob.sql
@@prvtlob.plb

Rem pl/sql package for REFs (UTL_REF)
@@utlrefld.sql

Rem pl/sql package for COLLs (UTL_COLL)
@@utlcoll.plb
@@prvtcoll.plb

Rem pl/sql package for distributed trust administration (trusted list admin)
@@dbmstrst
@@prvttrst.plb

Rem on-disk versions of rman support
@@dbmsrman.sql
@@prvtrmns.plb
@@dbmsbkrs.sql
@@prvtbkrs.plb

REM packages for Redo LogMiner
@@dbmslmd.sql
@@dbmslm.sql
@@prvtlm.plb

Rem SNMP catalog objects:  need to be here since script does a DROP USER
@@catsnmp.sql

Rem Row Level Security package and catalog views
@@catrls
@@dbmsrlsa
@@prvtrlsa.plb

Rem Stored outline package and catalog views
@@catol.sql
@@dbmsol.sql
@@prvtol.plb

Rem Script for Extensibility types
@@catodci.sql

Rem Data/Index Repair Package
@@dbmsrpr.sql
@@prvtrpr.plb

Rem System event attribute functions
@@dbmstrig.sql

